//--------------------------------------------------------------------------------------------------------------------//
//                                                REFERENCE COUNTING CLASS                                            //
// 18/06/00, Mythos                                                                                                   //
//      rem: most of the time this class is going to be used with the SmartPtr template                               //
//           'delete this' in vReleaseRef() implies that counted objects are allocated with 'new'                     //
//--------------------------------------------------------------------------------------------------------------------//

#ifndef   _REFCOUNT_H_
#define   _REFCOUNT_H_
#pragma    once

//----------------------------------------------- CLASSES ------------------------------------------------------------//

//--------------------------------------------------------------------------------------------------------------------//
//                                                CRefCount                                                           //
//--------------------------------------------------------------------------------------------------------------------//

class CRefCount
  {
// public methods

  public:

    // counting

    void            vAddRef             (void);
    void            vReleaseRef         (void);
    DWORD           dwGetRefCount       (void) const;

    void            vSetAutoDelete      (const bool boAuto);          // disable auto-deletion (see RefCount.inl)

// protected methods

  protected:

    // constructors & destructor

                    CRefCount           (void);
                    CRefCount           (const CRefCount& RefCount);
    virtual        ~CRefCount           (void);

    // operators

    CRefCount&      operator =          (const CRefCount& RefCount);

// private members

  private:

    DWORD           m_dwRefCount;
    bool            m_boAutoDelete;                                   // default behaviour = true
  };

//----------------------------------------------- INLINES ------------------------------------------------------------//

#include  "RefCount.inl"

//--------------------------------------------------------------------------------------------------------------------//

#endif // _REFCOUNT_H_
