//--------------------------------------------------------------------------------------------------------------------//
//                                                REFERENCE COUNTING CLASS                                            //
// 18/06/00, Mythos                                                                                                   //
//--------------------------------------------------------------------------------------------------------------------//

#ifndef   _REFCOUNT_INL_
#define   _REFCOUNT_INL_

//--------------------------------------------------------------------------------------------------------------------//
//                                                COUNTING                                                            //
//--------------------------------------------------------------------------------------------------------------------//

inline void CRefCount::vAddRef()
  {
  m_dwRefCount++;
  }

inline void CRefCount::vReleaseRef()
  {
  m_dwRefCount--;
  if(!m_dwRefCount && m_boAutoDelete) delete this;
  }

inline DWORD CRefCount::dwGetRefCount() const
  {
  return m_dwRefCount;
  }

// rem: I've had a case where I needed to use a smart pointer with an object allocated on the heap;
//      calling vSetAutoDelete(false) prevents the object to be wrongly deleted in vReleaseRef()

inline void CRefCount::vSetAutoDelete(const bool boAuto)
  {
  m_boAutoDelete = boAuto;
  }

//--------------------------------------------------------------------------------------------------------------------//
//                                                CONSTRUCTORS / DESTRUCTOR                                           //
//--------------------------------------------------------------------------------------------------------------------//

inline CRefCount::CRefCount() : m_dwRefCount(0), m_boAutoDelete(true)
  {}

inline CRefCount::CRefCount(const CRefCount& RefCount) : m_dwRefCount(0), m_boAutoDelete(true)
  {}

inline CRefCount::~CRefCount()
  {}

//--------------------------------------------------------------------------------------------------------------------//
//                                                OPERATORS                                                           //
//--------------------------------------------------------------------------------------------------------------------//

inline CRefCount& CRefCount::operator = (const CRefCount& RefCount)
  {
  return *this;
  }

//--------------------------------------------------------------------------------------------------------------------//

#endif // _REFCOUNT_INL_
