//--------------------------------------------------------------------------------------------------------------------//
//                                                SMART POINTER TEMPLATE                                              //
// 18/06/00, Mythos                                                                                                   //
//      rem: smart pointer to T : T must inherit from CRefCount                                                       //
//--------------------------------------------------------------------------------------------------------------------//

#ifndef   _SMARTPTR_H_
#define   _SMARTPTR_H_
#pragma    once

//----------------------------------------------- CLASSES ------------------------------------------------------------//

//--------------------------------------------------------------------------------------------------------------------//
//                                                CSmartPtr                                                           //
//--------------------------------------------------------------------------------------------------------------------//

template <class CObj> class CSmartPtr
  {
// public methods

  public:
                    CSmartPtr           (CObj* pObj=NULL);
                    CSmartPtr           (const CSmartPtr& Smart);
                   ~CSmartPtr           (void);

    // operators

    CSmartPtr&      operator =          (const CSmartPtr& Smart);
    CSmartPtr&      operator =          (CObj* pObj);

    CObj*           operator ->         (void) const;
    CObj&           operator *          (void) const;
    operator        CObj*               (void) const;

    bool            operator ==         (CObj* pObj) const;
    bool            operator !=         (CObj* pObj) const;
    bool            operator ==         (const CSmartPtr& Smart) const;
    bool            operator !=         (const CSmartPtr& Smart) const;

    // dumb pointer

    CObj*           pGetDumb            (void) const;

// protected members

  protected:

    CObj*           m_pDumbPtr;                             // pointed object
  };

//----------------------------------------------- MACROS -------------------------------------------------------------//

// CSmartPointer(Class); => defines the ClassPtr type (smart ptr to an object of class 'Class')

#define   CSmartPointer(Class)  \
          class   Class;        \
          typedef CSmartPtr<Class> Class##Ptr;

//----------------------------------------------- INLINES ------------------------------------------------------------//

#include  "SmartPtr.inl"

//--------------------------------------------------------------------------------------------------------------------//

#endif // _SMARTPTR_H_
